--- //depot/projects/trustedbsd/mac/sys/kern/sysv_msg.c	2003/02/21 10:04:40
+++ //depot/user/hdandeka/rishi_SystemVIPC/sys/kern/sysv_msg.c	2003/06/20 08:44:14
@@ -20,6 +20,7 @@
  */
 
 #include "opt_sysvipc.h"
+#include "opt_mac.h"
 
 #include <sys/param.h>
 #include <sys/systm.h>
@@ -34,6 +35,11 @@
 #include <sys/sysctl.h>
 #include <sys/malloc.h>
 #include <sys/jail.h>
+#ifdef MAC
+#include <sys/msg_msg.h>
+#include <sys/_label.h>
+#include <sys/mac.h>
+#endif
 
 static MALLOC_DEFINE(M_MSG, "msg", "SVID compatible message queues");
 
@@ -55,6 +61,8 @@
 	(sy_call_t *)msgsnd, (sy_call_t *)msgrcv
 };
 
+#ifndef MAC
+/* For the MAC framework, struct moved to the header file sys/msg_msg.h */
 struct msg {
 	struct	msg *msg_next;	/* next msg in the chain */
 	long	msg_type;	/* type of this message */
@@ -63,6 +71,7 @@
 	u_short	msg_ts;		/* size of this message */
 	short	msg_spot;	/* location of start of msg in buffer */
 };
+#endif
 
 
 #ifndef MSGSSZ
@@ -128,8 +137,10 @@
 static char *msgpool;		/* MSGMAX byte long msg buffer pool */
 static struct msgmap *msgmaps;	/* MSGSEG msgmap structures */
 static struct msg *msghdrs;	/* MSGTQL msg headers */
-static struct msqid_ds *msqids;	/* MSGMNI msqid_ds struct's */
+static struct msqid_kernel *msqids;	/* MSGMNI msqid_kernel struct's */
 static struct mtx msq_mtx;	/* global mutex for message queues. */
+static int refcount; /* to ensure consistency during and after msgunload */
+static struct mtx refcnt_mtx;	/* global mutex for refcount. */
 
 static void
 msginit()
@@ -150,7 +161,7 @@
 	msghdrs = malloc(sizeof(struct msg) * msginfo.msgtql, M_MSG, M_WAITOK);
 	if (msghdrs == NULL)
 		panic("msghdrs is NULL");
-	msqids = malloc(sizeof(struct msqid_ds) * msginfo.msgmni, M_MSG, M_WAITOK);
+	msqids = malloc(sizeof(struct msqid_kernel) * msginfo.msgmni, M_MSG, M_WAITOK);
 	if (msqids == NULL)
 		panic("msqids is NULL");
 
@@ -193,6 +204,9 @@
 		if (i > 0)
 			msghdrs[i-1].msg_next = &msghdrs[i];
 		msghdrs[i].msg_next = NULL;
+#ifdef MAC
+		mac_init_ipc_msgmsg(&msghdrs[i]);
+#endif
     	}
 	free_msghdrs = &msghdrs[0];
 
@@ -200,19 +214,44 @@
 		panic("msqids is NULL");
 
 	for (i = 0; i < msginfo.msgmni; i++) {
-		msqids[i].msg_qbytes = 0;	/* implies entry is available */
-		msqids[i].msg_perm.seq = 0;	/* reset to a known value */
-		msqids[i].msg_perm.mode = 0;
+		msqids[i].u.msg_qbytes = 0;	/* implies entry is available */
+		msqids[i].u.msg_perm.seq = 0;	/* reset to a known value */
+		msqids[i].u.msg_perm.mode = 0;
+#ifdef MAC
+		mac_init_ipc_msgqueue(&msqids[i]);
+#endif
 	}
 	mtx_init(&msq_mtx, "msq", NULL, MTX_DEF);
+	refcount = 0;
+	/* 
+	 * It is not permissible to pass the same mutex to mtx_init() multiple 
+	 * times without intervening calls to mtx_destroy().
+	 * Since we cannot destroy the refcnt_mtx during msgunload, we check if the 
+	 * mtx_init has ever been called. If so, we dont need to do mtx_init as the 
+	 * mutex is already initialized.
+	 */
+	if ( mtx_initialized(&refcnt_mtx) == 0 )
+		mtx_init(&refcnt_mtx, "msgrefcnt", NULL, MTX_DEF);
 }
 
 static int
 msgunload()
 {
-	struct msqid_ds *msqptr;
+	struct msqid_kernel *msqkptr;
 	int msqid;
 
+	/* 
+	 * Make sure that the msgunload maintains the consistency of the msqids
+	 * and msghdrs data structures. This assures that the unload doesn't take
+	 * place if any thread is in any of the code-paths (tinkering with the
+	 * data structures), and also that no thread can enter the code-paths once
+	 * the module is unloaded. 
+	 */
+	mtx_lock(&refcnt_mtx);
+	if (refcount > 0) {
+		mtx_unlock(&refcnt_mtx);
+		return (EBUSY);
+	}
 	for (msqid = 0; msqid < msginfo.msgmni; msqid++) {
 		/*
 		 * Look for an unallocated and unlocked msqid_ds.
@@ -220,19 +259,38 @@
 		 * they are copying the message in/out.  We can't
 		 * re-use the entry until they release it.
 		 */
-		msqptr = &msqids[msqid];
-		if (msqptr->msg_qbytes != 0 ||
-		    (msqptr->msg_perm.mode & MSG_LOCKED) != 0)
+		msqkptr = &msqids[msqid];
+		if (msqkptr->u.msg_qbytes != 0 ||
+		    (msqkptr->u.msg_perm.mode & MSG_LOCKED) != 0)
 			break;
 	}
-	if (msqid != msginfo.msgmni)
+	if (msqid != msginfo.msgmni) {
+		mtx_unlock(&refcnt_mtx);
 		return (EBUSY);
+	}
+
+	refcount= -1; /* Mark the module as being unloaded */
+	mtx_unlock(&refcnt_mtx);
 
+#ifdef MAC
+	int i;
+	/* Clean up the MAC label associated with the msg objects. */
+	for (i = 0; i < msginfo.msgtql; i++) 
+		mac_destroy_ipc_msgmsg(&msghdrs[i]);
+	/* Clean up the MAC label associated with the msq objects. */
+	for (msqid = 0; msqid < msginfo.msgmni; msqid++) 
+		mac_destroy_ipc_msgqueue(&msqids[msqid]);
+#endif 
 	free(msgpool, M_MSG);
 	free(msgmaps, M_MSG);
 	free(msghdrs, M_MSG);
 	free(msqids, M_MSG);
 	mtx_destroy(&msq_mtx);
+	/* 
+	 * NOTE: We cannot destroy the refcnt_mtx as it is possible that some thread
+	 * might (attempt to) hold the mutex.
+	 */
+/* 	mtx_destroy(&refcnt_mtx); */
 	return (0);
 }
 
@@ -324,6 +382,10 @@
 		panic("msghdr->msg_spot != -1");
 	msghdr->msg_next = free_msghdrs;
 	free_msghdrs = msghdr;
+#ifdef MAC
+	/* XXX: Reset the MAC label */
+	mac_cleanup_ipc_msgmsg(msghdr);
+#endif
 }
 
 #ifndef _SYS_SYSPROTO_H_
@@ -347,76 +409,116 @@
 	struct msqid_ds *user_msqptr = uap->buf;
 	int rval, error;
 	struct msqid_ds msqbuf;
-	register struct msqid_ds *msqptr;
+	register struct msqid_kernel *msqkptr;
 
 	DPRINTF(("call to msgctl(%d, %d, 0x%x)\n", msqid, cmd, user_msqptr));
 	if (!jail_sysvipc_allowed && jailed(td->td_ucred))
 		return (ENOSYS);
 
+	/* Prevent thread from going any further if module is (being) unloaded */
+	mtx_lock(&refcnt_mtx);
+	if (refcount < 0 ) {
+		mtx_unlock(&refcnt_mtx);
+		return (ENOSYS);
+	}
+	refcount++; /* Indicate that thread is active in the code-path */
+	mtx_unlock(&refcnt_mtx);
+
 	msqid = IPCID_TO_IX(msqid);
 
 	if (msqid < 0 || msqid >= msginfo.msgmni) {
 		DPRINTF(("msqid (%d) out of range (0<=msqid<%d)\n", msqid,
 		    msginfo.msgmni));
-		return (EINVAL);
+		error = EINVAL;
+		goto done3;
 	}
 	if (cmd == IPC_SET &&
-	    (error = copyin(user_msqptr, &msqbuf, sizeof(msqbuf))) != 0)
-		return (error);
+	    (error = copyin(user_msqptr, &msqbuf, sizeof(msqbuf))) != 0) 
+		goto done3;
 
-	msqptr = &msqids[msqid];
+	msqkptr = &msqids[msqid];
 
 	mtx_lock(&msq_mtx);
-	if (msqptr->msg_qbytes == 0) {
+	if (msqkptr->u.msg_qbytes == 0) {
 		DPRINTF(("no such msqid\n"));
 		error = EINVAL;
 		goto done2;
 	}
-	if (msqptr->msg_perm.seq != IPCID_TO_SEQ(uap->msqid)) {
+	if (msqkptr->u.msg_perm.seq != IPCID_TO_SEQ(uap->msqid)) {
 		DPRINTF(("wrong sequence number\n"));
 		error = EINVAL;
 		goto done2;
 	}
+#ifdef MAC
+	if ((error = mac_check_ipc_msqctl(td->td_ucred,msqkptr,cmd)))
+		goto done2;
+#endif
 
 	error = 0;
 	rval = 0;
 
+
 	switch (cmd) {
 
 	case IPC_RMID:
 	{
 		struct msg *msghdr;
-		if ((error = ipcperm(td, &msqptr->msg_perm, IPC_M)))
+		if ((error = ipcperm(td, &msqkptr->u.msg_perm, IPC_M)))
 			goto done2;
+
+#ifdef MAC
+		/* 
+		 * Check that the thread has MAC access permissions to individual msghdrs.
+		 * Note: We need to do this in a separate loop because the actual loop 
+		 * alters the msq/msghdr info as it progresses, and there is no going back 
+		 * if half the way through we discover that the thread cannot free a 
+		 * certain msghdr. The msq will get into an inconsistent state.
+		 */
+		msghdr = msqkptr->u.msg_first;
+		while (msghdr != NULL) {
+			if((error=	mac_check_ipc_msgrmid(td->td_ucred,msghdr))) {
+				DPRINTF(("MAC Framework: mac_check_ipc_msgrmid permission denied\n"));
+				/* XXX wakeup(msqkptr); ??? */
+				goto done2;
+			}
+			msghdr = msghdr->msg_next;
+		}
+#endif
+
 		/* Free the message headers */
-		msghdr = msqptr->msg_first;
+		msghdr = msqkptr->u.msg_first;
 		while (msghdr != NULL) {
 			struct msg *msghdr_tmp;
 
 			/* Free the segments of each message */
-			msqptr->msg_cbytes -= msghdr->msg_ts;
-			msqptr->msg_qnum--;
+			msqkptr->u.msg_cbytes -= msghdr->msg_ts;
+			msqkptr->u.msg_qnum--;
 			msghdr_tmp = msghdr;
 			msghdr = msghdr->msg_next;
 			msg_freehdr(msghdr_tmp);
 		}
 
-		if (msqptr->msg_cbytes != 0)
+		if (msqkptr->u.msg_cbytes != 0)
 			panic("msg_cbytes is screwed up");
-		if (msqptr->msg_qnum != 0)
+		if (msqkptr->u.msg_qnum != 0)
 			panic("msg_qnum is screwed up");
 
-		msqptr->msg_qbytes = 0;	/* Mark it as free */
+		msqkptr->u.msg_qbytes = 0;	/* Mark it as free */
+
+#ifdef MAC
+		/* XXX: Reset the MAC label */
+		mac_cleanup_ipc_msgqueue(msqkptr);
+#endif
 
-		wakeup(msqptr);
+		wakeup(msqkptr);
 	}
 
 		break;
 
 	case IPC_SET:
-		if ((error = ipcperm(td, &msqptr->msg_perm, IPC_M)))
+		if ((error = ipcperm(td, &msqkptr->u.msg_perm, IPC_M)))
 			goto done2;
-		if (msqbuf.msg_qbytes > msqptr->msg_qbytes) {
+		if (msqbuf.msg_qbytes > msqkptr->u.msg_qbytes) {
 			error = suser(td);
 			if (error)
 				goto done2;
@@ -431,16 +533,16 @@
 			error = EINVAL;		/* non-standard errno! */
 			goto done2;
 		}
-		msqptr->msg_perm.uid = msqbuf.msg_perm.uid;	/* change the owner */
-		msqptr->msg_perm.gid = msqbuf.msg_perm.gid;	/* change the owner */
-		msqptr->msg_perm.mode = (msqptr->msg_perm.mode & ~0777) |
+		msqkptr->u.msg_perm.uid = msqbuf.msg_perm.uid;	/* change the owner */
+		msqkptr->u.msg_perm.gid = msqbuf.msg_perm.gid;	/* change the owner */
+		msqkptr->u.msg_perm.mode = (msqkptr->u.msg_perm.mode & ~0777) |
 		    (msqbuf.msg_perm.mode & 0777);
-		msqptr->msg_qbytes = msqbuf.msg_qbytes;
-		msqptr->msg_ctime = time_second;
+		msqkptr->u.msg_qbytes = msqbuf.msg_qbytes;
+		msqkptr->u.msg_ctime = time_second;
 		break;
 
 	case IPC_STAT:
-		if ((error = ipcperm(td, &msqptr->msg_perm, IPC_R))) {
+		if ((error = ipcperm(td, &msqkptr->u.msg_perm, IPC_R))) {
 			DPRINTF(("requester doesn't have read access\n"));
 			goto done2;
 		}
@@ -457,7 +559,11 @@
 done2:
 	mtx_unlock(&msq_mtx);
 	if (cmd == IPC_STAT && error == 0)
-		error = copyout(msqptr, user_msqptr, sizeof(struct msqid_ds));
+		error = copyout(&(msqkptr->u), user_msqptr, sizeof(struct msqid_ds));
+done3:
+	mtx_lock(&refcnt_mtx);
+	refcount--; /* Indicate that thread no longer active in the code-path */
+	mtx_unlock(&refcnt_mtx);
 	return(error);
 }
 
@@ -480,19 +586,28 @@
 	int key = uap->key;
 	int msgflg = uap->msgflg;
 	struct ucred *cred = td->td_ucred;
-	register struct msqid_ds *msqptr = NULL;
+	register struct msqid_kernel *msqkptr = NULL;
 
 	DPRINTF(("msgget(0x%x, 0%o)\n", key, msgflg));
 
 	if (!jail_sysvipc_allowed && jailed(td->td_ucred))
 		return (ENOSYS);
 
+	/* Prevent thread from going any further if module is (being) unloaded */
+	mtx_lock(&refcnt_mtx);
+	if (refcount < 0 ) {
+		mtx_unlock(&refcnt_mtx);
+		return (ENOSYS);
+	}
+	refcount++;	/* Indicate that thread is active in the code-path */
+	mtx_unlock(&refcnt_mtx);
+
 	mtx_lock(&msq_mtx);
 	if (key != IPC_PRIVATE) {
 		for (msqid = 0; msqid < msginfo.msgmni; msqid++) {
-			msqptr = &msqids[msqid];
-			if (msqptr->msg_qbytes != 0 &&
-			    msqptr->msg_perm.key == key)
+			msqkptr = &msqids[msqid];
+			if (msqkptr->u.msg_qbytes != 0 &&
+			    msqkptr->u.msg_perm.key == key)
 				break;
 		}
 		if (msqid < msginfo.msgmni) {
@@ -502,11 +617,17 @@
 				error = EEXIST;
 				goto done2;
 			}
-			if ((error = ipcperm(td, &msqptr->msg_perm, msgflg & 0700 ))) {
+			if ((error = ipcperm(td, &msqkptr->u.msg_perm, msgflg & 0700 ))) {
 				DPRINTF(("requester doesn't have 0%o access\n",
 				    msgflg & 0700));
 				goto done2;
 			}
+#ifdef MAC
+			if(( error = mac_check_ipc_msqget(cred, msqkptr) )) {
+				DPRINTF(("MAC Framework:  mac_check_ipc_msqget access denied\n"));
+				goto done2;
+			}
+#endif
 			goto found;
 		}
 	}
@@ -520,9 +641,9 @@
 			 * they are copying the message in/out.  We can't
 			 * re-use the entry until they release it.
 			 */
-			msqptr = &msqids[msqid];
-			if (msqptr->msg_qbytes == 0 &&
-			    (msqptr->msg_perm.mode & MSG_LOCKED) == 0)
+			msqkptr = &msqids[msqid];
+			if (msqkptr->u.msg_qbytes == 0 &&
+			    (msqkptr->u.msg_perm.mode & MSG_LOCKED) == 0)
 				break;
 		}
 		if (msqid == msginfo.msgmni) {
@@ -531,24 +652,27 @@
 			goto done2;
 		}
 		DPRINTF(("msqid %d is available\n", msqid));
-		msqptr->msg_perm.key = key;
-		msqptr->msg_perm.cuid = cred->cr_uid;
-		msqptr->msg_perm.uid = cred->cr_uid;
-		msqptr->msg_perm.cgid = cred->cr_gid;
-		msqptr->msg_perm.gid = cred->cr_gid;
-		msqptr->msg_perm.mode = (msgflg & 0777);
+		msqkptr->u.msg_perm.key = key;
+		msqkptr->u.msg_perm.cuid = cred->cr_uid;
+		msqkptr->u.msg_perm.uid = cred->cr_uid;
+		msqkptr->u.msg_perm.cgid = cred->cr_gid;
+		msqkptr->u.msg_perm.gid = cred->cr_gid;
+		msqkptr->u.msg_perm.mode = (msgflg & 0777);
 		/* Make sure that the returned msqid is unique */
-		msqptr->msg_perm.seq = (msqptr->msg_perm.seq + 1) & 0x7fff;
-		msqptr->msg_first = NULL;
-		msqptr->msg_last = NULL;
-		msqptr->msg_cbytes = 0;
-		msqptr->msg_qnum = 0;
-		msqptr->msg_qbytes = msginfo.msgmnb;
-		msqptr->msg_lspid = 0;
-		msqptr->msg_lrpid = 0;
-		msqptr->msg_stime = 0;
-		msqptr->msg_rtime = 0;
-		msqptr->msg_ctime = time_second;
+		msqkptr->u.msg_perm.seq = (msqkptr->u.msg_perm.seq + 1) & 0x7fff;
+		msqkptr->u.msg_first = NULL;
+		msqkptr->u.msg_last = NULL;
+		msqkptr->u.msg_cbytes = 0;
+		msqkptr->u.msg_qnum = 0;
+		msqkptr->u.msg_qbytes = msginfo.msgmnb;
+		msqkptr->u.msg_lspid = 0;
+		msqkptr->u.msg_lrpid = 0;
+		msqkptr->u.msg_stime = 0;
+		msqkptr->u.msg_rtime = 0;
+		msqkptr->u.msg_ctime = time_second;
+#ifdef MAC
+		mac_create_ipc_msgqueue(cred, msqkptr);
+#endif
 	} else {
 		DPRINTF(("didn't find it and wasn't asked to create it\n"));
 		error = ENOENT;
@@ -557,9 +681,12 @@
 
 found:
 	/* Construct the unique msqid */
-	td->td_retval[0] = IXSEQ_TO_IPCID(msqid, msqptr->msg_perm);
+	td->td_retval[0] = IXSEQ_TO_IPCID(msqid, msqkptr->u.msg_perm);
 done2:
 	mtx_unlock(&msq_mtx);
+	mtx_lock(&refcnt_mtx);
+	refcount--; /* Indicate that thread no longer active in the code-path */
+	mtx_unlock(&refcnt_mtx);
 	return (error);
 }
 
@@ -585,7 +712,7 @@
 	size_t msgsz = uap->msgsz;
 	int msgflg = uap->msgflg;
 	int segs_needed, error = 0;
-	register struct msqid_ds *msqptr;
+	register struct msqid_kernel *msqkptr;
 	register struct msg *msghdr;
 	short next;
 
@@ -594,6 +721,15 @@
 	if (!jail_sysvipc_allowed && jailed(td->td_ucred))
 		return (ENOSYS);
 
+	/* Prevent thread from going any further if module is (being) unloaded */
+	mtx_lock(&refcnt_mtx);
+	if (refcount < 0 ) {
+		mtx_unlock(&refcnt_mtx);
+		return (ENOSYS);
+	}
+	refcount++;	/* Indicate that thread is active in the code-path */
+	mtx_unlock(&refcnt_mtx);
+
 	mtx_lock(&msq_mtx);
 	msqid = IPCID_TO_IX(msqid);
 
@@ -604,23 +740,31 @@
 		goto done2;
 	}
 
-	msqptr = &msqids[msqid];
-	if (msqptr->msg_qbytes == 0) {
+	msqkptr = &msqids[msqid];
+	if (msqkptr->u.msg_qbytes == 0) {
 		DPRINTF(("no such message queue id\n"));
 		error = EINVAL;
 		goto done2;
 	}
-	if (msqptr->msg_perm.seq != IPCID_TO_SEQ(uap->msqid)) {
+	if (msqkptr->u.msg_perm.seq != IPCID_TO_SEQ(uap->msqid)) {
 		DPRINTF(("wrong sequence number\n"));
 		error = EINVAL;
 		goto done2;
 	}
 
-	if ((error = ipcperm(td, &msqptr->msg_perm, IPC_W))) {
+	if ((error = ipcperm(td, &msqkptr->u.msg_perm, IPC_W))) {
 		DPRINTF(("requester doesn't have write access\n"));
 		goto done2;
 	}
 
+#ifdef MAC 
+	/* Make sure that the thread has  access rights to the message queue */
+	if ((error = mac_check_ipc_msqsnd(td->td_ucred, msqkptr))) {
+		DPRINTF(("MAC Framework: mac_check_ipc_msqsnd permission denied\n"));
+		goto done2;
+	}
+#endif
+
 	segs_needed = (msgsz + msginfo.msgssz - 1) / msginfo.msgssz;
 	DPRINTF(("msgsz=%d, msgssz=%d, segs_needed=%d\n", msgsz, msginfo.msgssz,
 	    segs_needed));
@@ -632,17 +776,17 @@
 		 * (inside this loop in case msg_qbytes changes while we sleep)
 		 */
 
-		if (msgsz > msqptr->msg_qbytes) {
-			DPRINTF(("msgsz > msqptr->msg_qbytes\n"));
+		if (msgsz > msqkptr->u.msg_qbytes) {
+			DPRINTF(("msgsz > msqkptr->u.msg_qbytes\n"));
 			error = EINVAL;
 			goto done2;
 		}
 
-		if (msqptr->msg_perm.mode & MSG_LOCKED) {
+		if (msqkptr->u.msg_perm.mode & MSG_LOCKED) {
 			DPRINTF(("msqid is locked\n"));
 			need_more_resources = 1;
 		}
-		if (msgsz + msqptr->msg_cbytes > msqptr->msg_qbytes) {
+		if (msgsz + msqkptr->u.msg_cbytes > msqkptr->u.msg_qbytes) {
 			DPRINTF(("msgsz + msg_cbytes > msg_qbytes\n"));
 			need_more_resources = 1;
 		}
@@ -665,22 +809,22 @@
 				goto done2;
 			}
 
-			if ((msqptr->msg_perm.mode & MSG_LOCKED) != 0) {
+			if ((msqkptr->u.msg_perm.mode & MSG_LOCKED) != 0) {
 				DPRINTF(("we don't own the msqid_ds\n"));
 				we_own_it = 0;
 			} else {
 				/* Force later arrivals to wait for our
 				   request */
 				DPRINTF(("we own the msqid_ds\n"));
-				msqptr->msg_perm.mode |= MSG_LOCKED;
+				msqkptr->u.msg_perm.mode |= MSG_LOCKED;
 				we_own_it = 1;
 			}
 			DPRINTF(("goodnight\n"));
-			error = msleep(msqptr, &msq_mtx, (PZERO - 4) | PCATCH,
+			error = msleep(msqkptr, &msq_mtx, (PZERO - 4) | PCATCH,
 			    "msgwait", 0);
 			DPRINTF(("good morning, error=%d\n", error));
 			if (we_own_it)
-				msqptr->msg_perm.mode &= ~MSG_LOCKED;
+				msqkptr->u.msg_perm.mode &= ~MSG_LOCKED;
 			if (error != 0) {
 				DPRINTF(("msgsnd:  interrupted system call\n"));
 				error = EINTR;
@@ -691,7 +835,7 @@
 			 * Make sure that the msq queue still exists
 			 */
 
-			if (msqptr->msg_qbytes == 0) {
+			if (msqkptr->u.msg_qbytes == 0) {
 				DPRINTF(("msqid deleted\n"));
 				error = EIDRM;
 				goto done2;
@@ -708,11 +852,11 @@
 	 * Make sure!
 	 */
 
-	if (msqptr->msg_perm.mode & MSG_LOCKED)
+	if (msqkptr->u.msg_perm.mode & MSG_LOCKED)
 		panic("msg_perm.mode & MSG_LOCKED");
 	if (segs_needed > nfree_msgmaps)
 		panic("segs_needed > nfree_msgmaps");
-	if (msgsz + msqptr->msg_cbytes > msqptr->msg_qbytes)
+	if (msgsz + msqkptr->u.msg_cbytes > msqkptr->u.msg_qbytes)
 		panic("msgsz + msg_cbytes > msg_qbytes");
 	if (free_msghdrs == NULL)
 		panic("no more msghdrs");
@@ -722,9 +866,9 @@
 	 * message
 	 */
 
-	if ((msqptr->msg_perm.mode & MSG_LOCKED) != 0)
+	if ((msqkptr->u.msg_perm.mode & MSG_LOCKED) != 0)
 		panic("msqid_ds is already locked");
-	msqptr->msg_perm.mode |= MSG_LOCKED;
+	msqkptr->u.msg_perm.mode |= MSG_LOCKED;
 
 	/*
 	 * Allocate a message header
@@ -734,6 +878,15 @@
 	free_msghdrs = msghdr->msg_next;
 	msghdr->msg_spot = -1;
 	msghdr->msg_ts = msgsz;
+#ifdef MAC
+	mac_create_ipc_msgmsg(td->td_ucred,msghdr);
+	/* 
+	 * XXX: Should the mac_check_ipc_msgmsq check follow here immediately ? 
+	 * Or, should it be checked just before the msg is enqueued in the msgq 
+	 * (as it is done now) ?
+	 */
+
+#endif
 
 	/*
 	 * Allocate space for the message
@@ -767,8 +920,8 @@
 		mtx_lock(&msq_mtx);
 		DPRINTF(("error %d copying the message type\n", error));
 		msg_freehdr(msghdr);
-		msqptr->msg_perm.mode &= ~MSG_LOCKED;
-		wakeup(msqptr);
+		msqkptr->u.msg_perm.mode &= ~MSG_LOCKED;
+		wakeup(msqkptr);
 		goto done2;
 	}
 	mtx_lock(&msq_mtx);
@@ -780,8 +933,8 @@
 
 	if (msghdr->msg_type < 1) {
 		msg_freehdr(msghdr);
-		msqptr->msg_perm.mode &= ~MSG_LOCKED;
-		wakeup(msqptr);
+		msqkptr->u.msg_perm.mode &= ~MSG_LOCKED;
+		wakeup(msqkptr);
 		DPRINTF(("mtype (%d) < 1\n", msghdr->msg_type));
 		error = EINVAL;
 		goto done2;
@@ -809,8 +962,8 @@
 			DPRINTF(("error %d copying in message segment\n",
 			    error));
 			msg_freehdr(msghdr);
-			msqptr->msg_perm.mode &= ~MSG_LOCKED;
-			wakeup(msqptr);
+			msqkptr->u.msg_perm.mode &= ~MSG_LOCKED;
+			wakeup(msqkptr);
 			goto done2;
 		}
 		mtx_lock(&msq_mtx);
@@ -825,15 +978,15 @@
 	 * We've got the message.  Unlock the msqid_ds.
 	 */
 
-	msqptr->msg_perm.mode &= ~MSG_LOCKED;
+	msqkptr->u.msg_perm.mode &= ~MSG_LOCKED;
 
 	/*
 	 * Make sure that the msqid_ds is still allocated.
 	 */
 
-	if (msqptr->msg_qbytes == 0) {
+	if (msqkptr->u.msg_qbytes == 0) {
 		msg_freehdr(msghdr);
-		wakeup(msqptr);
+		wakeup(msqkptr);
 		error = EIDRM;
 		goto done2;
 	}
@@ -842,24 +995,45 @@
 	 * Put the message into the queue
 	 */
 
-	if (msqptr->msg_first == NULL) {
-		msqptr->msg_first = msghdr;
-		msqptr->msg_last = msghdr;
+#ifdef MAC
+	/*
+	 * Note: Since the task/thread allocates the msghdr and usually primes it with
+	 * its own MAC label,for a majority of policies, it won't be necessary to 
+	 * check whether the msghdr has access permissions to the msgq 
+	 * The mac_check_ipc_msqsnd check would suffice in that case. However, this 
+	 * hook may be required where individual policies derive a non-identical label
+	 * for the msghdr from the current thread label and may want to check the 
+	 * msghdr enqueue permissions, along with read/write permissions to the msgq.
+	 */
+	if((error=	mac_check_ipc_msgmsq(td->td_ucred,msghdr,msqkptr))) {
+		DPRINTF(("MAC Framework: mac_check_ipc_msqmsq permission denied\n"));
+		msg_freehdr(msghdr);
+		wakeup(msqkptr);
+		goto done2;
+	}
+#endif
+
+	if (msqkptr->u.msg_first == NULL) {
+		msqkptr->u.msg_first = msghdr;
+		msqkptr->u.msg_last = msghdr;
 	} else {
-		msqptr->msg_last->msg_next = msghdr;
-		msqptr->msg_last = msghdr;
+		msqkptr->u.msg_last->msg_next = msghdr;
+		msqkptr->u.msg_last = msghdr;
 	}
-	msqptr->msg_last->msg_next = NULL;
+	msqkptr->u.msg_last->msg_next = NULL;
 
-	msqptr->msg_cbytes += msghdr->msg_ts;
-	msqptr->msg_qnum++;
-	msqptr->msg_lspid = td->td_proc->p_pid;
-	msqptr->msg_stime = time_second;
+	msqkptr->u.msg_cbytes += msghdr->msg_ts;
+	msqkptr->u.msg_qnum++;
+	msqkptr->u.msg_lspid = td->td_proc->p_pid;
+	msqkptr->u.msg_stime = time_second;
 
-	wakeup(msqptr);
+	wakeup(msqkptr);
 	td->td_retval[0] = 0;
 done2:
 	mtx_unlock(&msq_mtx);
+	mtx_lock(&refcnt_mtx);
+	refcount--; /* Indicate that thread no longer active in the code-path */
+	mtx_unlock(&refcnt_mtx);
 	return (error);
 }
 
@@ -887,7 +1061,7 @@
 	long msgtyp = uap->msgtyp;
 	int msgflg = uap->msgflg;
 	size_t len;
-	register struct msqid_ds *msqptr;
+	register struct msqid_kernel *msqkptr;
 	register struct msg *msghdr;
 	int error = 0;
 	short next;
@@ -898,36 +1072,54 @@
 	if (!jail_sysvipc_allowed && jailed(td->td_ucred))
 		return (ENOSYS);
 
+	/* Prevent thread from going any further if module is (being) unloaded */
+	mtx_lock(&refcnt_mtx);
+	if (refcount < 0 ) {
+		mtx_unlock(&refcnt_mtx);
+		return (ENOSYS);
+	}
+	refcount++;	/* Indicate that thread is active in the code-path */
+	mtx_unlock(&refcnt_mtx);
+
 	msqid = IPCID_TO_IX(msqid);
 
 	if (msqid < 0 || msqid >= msginfo.msgmni) {
 		DPRINTF(("msqid (%d) out of range (0<=msqid<%d)\n", msqid,
 		    msginfo.msgmni));
-		return (EINVAL);
+		error = EINVAL;
+		goto done3;
 	}
 
-	msqptr = &msqids[msqid];
+	msqkptr = &msqids[msqid];
 	mtx_lock(&msq_mtx);
-	if (msqptr->msg_qbytes == 0) {
+	if (msqkptr->u.msg_qbytes == 0) {
 		DPRINTF(("no such message queue id\n"));
 		error = EINVAL;
 		goto done2;
 	}
-	if (msqptr->msg_perm.seq != IPCID_TO_SEQ(uap->msqid)) {
+	if (msqkptr->u.msg_perm.seq != IPCID_TO_SEQ(uap->msqid)) {
 		DPRINTF(("wrong sequence number\n"));
 		error = EINVAL;
 		goto done2;
 	}
 
-	if ((error = ipcperm(td, &msqptr->msg_perm, IPC_R))) {
+	if ((error = ipcperm(td, &msqkptr->u.msg_perm, IPC_R))) {
 		DPRINTF(("requester doesn't have read access\n"));
 		goto done2;
 	}
 
+#ifdef MAC 
+	/* Make sure that the thread has access rights to the message queue */
+	if ((error = mac_check_ipc_msqrcv(td->td_ucred, msqkptr))) {
+		DPRINTF(("MAC Framework: mac_check_ipc_msqrcv permission denied\n"));
+		goto done2;
+	}
+#endif
+
 	msghdr = NULL;
 	while (msghdr == NULL) {
 		if (msgtyp == 0) {
-			msghdr = msqptr->msg_first;
+			msghdr = msqkptr->u.msg_first;
 			if (msghdr != NULL) {
 				if (msgsz < msghdr->msg_ts &&
 				    (msgflg & MSG_NOERROR) == 0) {
@@ -937,12 +1129,19 @@
 					error = E2BIG;
 					goto done2;
 				}
-				if (msqptr->msg_first == msqptr->msg_last) {
-					msqptr->msg_first = NULL;
-					msqptr->msg_last = NULL;
+#ifdef MAC
+	/* Make sure that the thread has access rights to the message header */
+				if ((error = mac_check_ipc_msgrcv(td->td_ucred, msghdr))) {
+					DPRINTF(("MAC Framework: mac_check_ipc_msgrcv permission denied\n"));
+					goto done2;
+				}
+#endif
+				if (msqkptr->u.msg_first == msqkptr->u.msg_last) {
+					msqkptr->u.msg_first = NULL;
+					msqkptr->u.msg_last = NULL;
 				} else {
-					msqptr->msg_first = msghdr->msg_next;
-					if (msqptr->msg_first == NULL)
+					msqkptr->u.msg_first = msghdr->msg_next;
+					if (msqkptr->u.msg_first == NULL)
 						panic("msg_first/last screwed up #1");
 				}
 			}
@@ -951,7 +1150,7 @@
 			struct msg **prev;
 
 			previous = NULL;
-			prev = &(msqptr->msg_first);
+			prev = &(msqkptr->u.msg_first);
 			while ((msghdr = *prev) != NULL) {
 				/*
 				 * Is this message's type an exact match or is
@@ -976,21 +1175,28 @@
 						error = E2BIG;
 						goto done2;
 					}
+#ifdef MAC
+				/* Make sure that the thread has access rights to the message header */
+					if ((error = mac_check_ipc_msgrcv(td->td_ucred, msghdr))) {
+						DPRINTF(("MAC Framework: mac_check_ipc_msgrcv permission denied\n"));
+						goto done2;
+					}
+#endif
 					*prev = msghdr->msg_next;
-					if (msghdr == msqptr->msg_last) {
+					if (msghdr == msqkptr->u.msg_last) {
 						if (previous == NULL) {
 							if (prev !=
-							    &msqptr->msg_first)
+							    &msqkptr->u.msg_first)
 								panic("msg_first/last screwed up #2");
-							msqptr->msg_first =
+							msqkptr->u.msg_first =
 							    NULL;
-							msqptr->msg_last =
+							msqkptr->u.msg_last =
 							    NULL;
 						} else {
 							if (prev ==
-							    &msqptr->msg_first)
+							    &msqkptr->u.msg_first)
 								panic("msg_first/last screwed up #3");
-							msqptr->msg_last =
+							msqkptr->u.msg_last =
 							    previous;
 						}
 					}
@@ -1027,7 +1233,7 @@
 		 */
 
 		DPRINTF(("msgrcv:  goodnight\n"));
-		error = msleep(msqptr, &msq_mtx, (PZERO - 4) | PCATCH,
+		error = msleep(msqkptr, &msq_mtx, (PZERO - 4) | PCATCH,
 		    "msgwait", 0);
 		DPRINTF(("msgrcv:  good morning (error=%d)\n", error));
 
@@ -1041,8 +1247,8 @@
 		 * Make sure that the msq queue still exists
 		 */
 
-		if (msqptr->msg_qbytes == 0 ||
-		    msqptr->msg_perm.seq != IPCID_TO_SEQ(uap->msqid)) {
+		if (msqkptr->u.msg_qbytes == 0 ||
+		    msqkptr->u.msg_perm.seq != IPCID_TO_SEQ(uap->msqid)) {
 			DPRINTF(("msqid deleted\n"));
 			error = EIDRM;
 			goto done2;
@@ -1055,10 +1261,10 @@
 	 * First, do the bookkeeping (before we risk being interrupted).
 	 */
 
-	msqptr->msg_cbytes -= msghdr->msg_ts;
-	msqptr->msg_qnum--;
-	msqptr->msg_lrpid = td->td_proc->p_pid;
-	msqptr->msg_rtime = time_second;
+	msqkptr->u.msg_cbytes -= msghdr->msg_ts;
+	msqkptr->u.msg_qnum--;
+	msqkptr->u.msg_lrpid = td->td_proc->p_pid;
+	msqkptr->u.msg_rtime = time_second;
 
 	/*
 	 * Make msgsz the actual amount that we'll be returning.
@@ -1082,7 +1288,7 @@
 	if (error != 0) {
 		DPRINTF(("error (%d) copying out message type\n", error));
 		msg_freehdr(msghdr);
-		wakeup(msqptr);
+		wakeup(msqkptr);
 		goto done2;
 	}
 	user_msgp = (char *)user_msgp + sizeof(msghdr->msg_type);
@@ -1111,7 +1317,7 @@
 			DPRINTF(("error (%d) copying out message segment\n",
 			    error));
 			msg_freehdr(msghdr);
-			wakeup(msqptr);
+			wakeup(msqkptr);
 			goto done2;
 		}
 		user_msgp = (char *)user_msgp + tlen;
@@ -1123,10 +1329,14 @@
 	 */
 
 	msg_freehdr(msghdr);
-	wakeup(msqptr);
+	wakeup(msqkptr);
 	td->td_retval[0] = msgsz;
 done2:
 	mtx_unlock(&msq_mtx);
+done3:
+	mtx_lock(&refcnt_mtx);
+	refcount--; /* Indicate that thread no longer active in the code-path */
+	mtx_unlock(&refcnt_mtx);
 	return (error);
 }
 
